import sys

n = len( sys.argv )
if n != 2 :
	print( "Args: n" )
	sys.exit(1)

n = int(sys.argv[1])
if n < 0 or n > 30 :
	print( "n debe ser positivo y menor que 30" )
	sys.exit(2)

#    0  1  2  3  4   5   6   7   8   9  10
p = [0, 1, 5, 8, 9, 10, 17, 17, 20, 24, 30, 20, 20, 20, 20, 20, 40, 40, 40, 40, 40, 30, 30, 30, 30, 30, 30, 50, 50, 50, 50, 50  ]

# p es un arreglo de precios
# n es un valor entero
def corta_varillas_abajo_arriba( p, n ) :
	r = [0]*(n+1)
	s = [0]*(n+1)
	j = 1
	while j <= n :
		q = 0
		i = 1
		while i <= j :
			if q < p[i] + r[j-i] :
				q = p[i] + r[j-i]
				s[j] = i 
			i += 1
		r[j] = q
		j += 1
	return r, s

def imprime_solucion_corta_varillas( r, s, n ) :
	i = n
	while i > 0 :
		print( s[i] )
		i -= s[i]

r, s = corta_varillas_abajo_arriba( p, n )
i = 0
while i <= n :
	print( i, r[i], s[i] )
	i += 1

print( "Cortes:" )
imprime_solucion_corta_varillas( r, s, n )
